require 'redis'
require 'hikki'
require_relative './redis_collection'

module Hikki
  module Adapters
    class RedisAdapter < Hikki::Adapters::Adapter
      attr_reader :connection, :uuid_generator

      def initialize(connection=Redis.new, uuid_generator=SecureRandom)
        super()
        @connection = connection
        @uuid_generator = uuid_generator
      end

      def collection_for(collection)
        collections.fetch(collection, RedisCollection.new(collection, connection, uuid_generator))
      end
    end
  end
end